diff --git a/pimd/pim_iface.c b/pimd/pim_iface.c
index 042cb4819136..5a2813f4aa77 100644
--- a/pimd/pim_iface.c
+++ b/pimd/pim_iface.c
@@ -831,6 +831,7 @@ void pim_if_addr_del_all(struct interface *ifp)
 	struct listnode *nextnode;
 	struct pim_instance *pim;
 	struct rp_info *rp_info;
+	struct pim_upstream *up;
 
 	pim = ifp->vrf->info;
 	if (!pim)
@@ -856,6 +857,13 @@ void pim_if_addr_del_all(struct interface *ifp)
 		}
 	}
 
+	frr_each (rb_pim_upstream, &pim->upstream_head, up) {
+		if (up->rpf.source_nexthop.interface &&
+		    up->rpf.source_nexthop.interface == ifp) {
+			pim_upstream_rpf_clear(pim, up);
+		}
+	}
+
 	pim_rp_setup(pim);
 	pim_i_am_rp_re_evaluate(pim);
 }
